from http import cookies
import models
import sessionutils


def index(request):
    print(request)
    korime = ""
    cookie = cookies.SimpleCookie(request['cookies'])
    if "session_id" in cookie:
        session_id = cookie['session_id'].value
        if "korisnik" in sessionutils.sessions[session_id]:
            korime = sessionutils.sessions[session_id]['korisnik']['korime']
    proizvodi = ""
    for k, v in models.dohvati_sve_proizvode():
        proizvodi += f"<option value='{k}'>{v['ime']}</option>"
    return "index.html", {"proizvodi": proizvodi, "korime": korime}, []


def results(request):
    print(request)
    cookie = cookies.SimpleCookie(request['cookies'])
    cookie['proizvodi'] = request["body"]["proizvodi"]
    cookie['broj'] = request["body"]["broj"]
    proizvod = models.dohvati_proizvod(cookie['proizvodi'].value)
    return "results.html", {"proizvod": proizvod['ime'] + ": " + proizvod["opis"], "broj": cookie['broj'].value}, [cookie['proizvodi'].output(header=''), cookie['broj'].output(header='')]


def view_cart(request):
    print(request)
    cookie = cookies.SimpleCookie(request['cookies'])
    try:
        proizvod = models.dohvati_proizvod(cookie['proizvodi'].value)
        return "results.html", {"proizvod": proizvod['ime'] + ": " + proizvod["opis"], "broj": cookie['broj'].value}, []
    except KeyError:
        return "results.html", {"proizvod": "Vasa korpa je prazna!", "broj": ""}, []


def view_add_proizvod(request):
    print(request)
    return "add_proizvod.html", {}, []


def login(request):
    print(request)
    return "login.html", {"poruka": ""}, []


def login_check(request):
    print(request)
    korisnik = models.login(request['body']['korime'], request['body']['lozinka'])
    if korisnik != {}:
        cookie = cookies.SimpleCookie(request['cookies'])
        session_id = sessionutils.generate_session_id()
        sessionutils.sessions[session_id] = dict()
        sessionutils.sessions[session_id]['korisnik'] = korisnik
        cookie['session_id'] = session_id
        sessionutils.save_to_file(session_id)
        session_cookie_output = cookie['session_id'].output(header='')
        proizvodi = ""
        for k, v in models.dohvati_sve_proizvode():
            proizvodi += f"<option value='{k}'>{v['ime']}</option>"
        return "index.html", {"proizvodi": proizvodi, "korime": request['body']['korime']}, [session_cookie_output]
    return "login.html", {"poruka": "<p style='color:red'>Neispravni kredencijali!</p>"}, []


def add_proizvod(request):
    print(request)
    models.dodaj_proizvod(request["body"]["ime"], request["body"]["opis"])
    korime = ""
    cookie = cookies.SimpleCookie(request['cookies'])
    if "session_id" in cookie:
        session_id = cookie['session_id'].value
        if "korisnik" in sessionutils.sessions[session_id]:
            korime = sessionutils.sessions[session_id]['korisnik']['korime']
    proizvodi = ""
    for k, v in models.dohvati_sve_proizvode():
        proizvodi += f"<option value='{k}'>{v['ime']}</option>"
    return "index.html", {"proizvodi": proizvodi, "korime": korime}, []

